/*****************************************************
CVAVR V2.05
Chip type               : ATtiny13A
AVR Core Clock frequency: 9,6 MHz
Project: hf sw inverter
*****************************************************/
#include <tiny13a.h>
typedef unsigned char u8;
typedef unsigned int u16;
typedef unsigned long u32;


#define HL	    PORTB.3
#define HR	    PORTB.4

u8 a=0xff, mst;
bit cntfb;


#define s_step 188
flash u8 s_table [s_step/2]=
{0,2,4,6,8,10,12,15,17,19,21,23,25,27,29,31,33,36,38,40,42,
44,46,48,50,52,54,56,58,59,61,63,65,67,69,71,72,74,76,77,79,81,
83,84,86,87,89,90,92,93,95,96,98,99,100,102,103,104,105,107,108,109,110,
111,112,113,114,115,116,117,118,118,119,120,121,121,122,123,123,124,124,125,125,126,
126,126,126,127,127,127,127,127,127,127};

void t0_cfg()
{
 TCCR0A=1<<COM0A1|1<<COM0A0|1<<COM0B1|1<<WGM00; 
 TCCR0B=1; OCR0A=0xff/2+5;OCR0B=0xff/2-5;  //phase correct pwm, top 0xff, no prsc
 TIMSK0|=1<<TOIE0;
}
void gpio_cfg()
{
 PORTB=0b11111011;
 DDRB =0b11111011;
}

interrupt [TIM0_OVF] void t0_ovf()
{
#define dtv 3
static bit d=1,ph=1;
static u8 mst=0xff, c=0;
u8 tmp_table;

tmp_table=((u16)s_table [c]*mst)>>8;
if(tmp_table>0xff/2){tmp_table=0xff/2;}

if(d)
 {
	if(tmp_table<0xff/2-dtv){OCR0A=tmp_table;OCR0B=0xff-tmp_table;}
	else                    {OCR0A=0xff/2-dtv;OCR0B=0xff/2+dtv;}
  
  if(c<s_step/2-1){c++;} else {d=0;}
 }
else
  {
	if(tmp_table<0xff/2-dtv){OCR0A=tmp_table;OCR0B=0xff-tmp_table;}
	else                    {OCR0A=0xff/2-dtv;OCR0B=0xff/2+dtv;}
  
  if(c){c--;}
	else
	{
     d=1; ph^=1;
	 if(ph){HL=1;HR=0; cntfb=1; mst=a;}
	 else  {HL=0;HR=1;}
	}
  }
   #asm ("wdr")
}            


void main(void)
{
gpio_cfg();
t0_cfg();



// Crystal Oscillator division factor: 1
#pragma optsize-
CLKPR=0x80;
CLKPR=0x00;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

#pragma optsize-
WDTCR=0x18;
WDTCR=0x08;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

#asm("sei")

while (1)
      {

         
      }
}
